import { ProcessedCharacter } from "../process";
import { Stream } from "../humanize";
export interface StrokedCharacter {
    index: [number, number] | [];
    character: string;
    processedCharacter: ProcessedCharacter;
}
export declare type StrokedStream = StrokedCharacter[];
export interface GenerateStrokedStream {
    stream: Stream;
}
export declare const generateStrokedStream: ({ stream }: GenerateStrokedStream) => StrokedCharacter[];
export interface SimulateTyping extends GenerateStrokedStream {
    pauseMin?: number;
    pauseMax?: number;
    onStroke({ stroke, previousStroke, strokedStream }: {
        stroke: StrokedCharacter;
        previousStroke: StrokedCharacter;
        strokedStream: StrokedStream;
    }): void | Promise<any>;
}
export declare const generateStrokeTiming: (options?: {
    pauseMin?: number;
    pauseMax?: number;
    prevCharacter?: string;
}) => number;
export declare const simulateStrokeTiming: (options?: {
    pauseMin?: number;
    pauseMax?: number;
    prevCharacter?: string;
}) => Promise<unknown>;
export declare const simulateTyping: ({ stream, onStroke, pauseMin, pauseMax }: SimulateTyping) => Promise<any[]>;
export declare const toString: (strokedStream: StrokedCharacter[]) => string;
